unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, MRVType, MRVReceiver, MRVSender,
  MRVMediaServer, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    RVMediaServer1: TRVMediaServer;
    RVCamSender1: TRVCamSender;
    RVCamReceiver1: TRVCamReceiver;
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    Edit1: TEdit;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Panel1: TPanel;
    RVCamSender2: TRVCamSender;
    RVCamReceiver2: TRVCamReceiver;
    Label3: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Button5: TButton;
    Edit4: TEdit;
    Button6: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure RVMediaServer1UserConnect(Sender: TRVMediaServer;
      const GUIDUser: TRVMAnsiString; MediaType: TRVMediaType);
    procedure RVCamReceiver1GetAllOnlineUsers(Sender: TRVCamReceiver;
      SessionKey: TRVSessionKey; const GUIDGroup, GUIDUser: TRVMAnsiString;
      ACmd: TRVCmd);
    procedure RVCamReceiver1GetAllUsers(Sender: TRVCamReceiver;
      SessionKey: TRVSessionKey; const GUIDGroup, GUIDUser: TRVMAnsiString;
      ACmd: TRVCmd);
    procedure Button4Click(Sender: TObject);
    procedure RVMediaServer1ServerCmd(Sender: TRVMediaServer; const GUIDUser,
      GUIDToUser, GUIDGroupUser: TRVMAnsiString; ServerCMD: TRVCmd);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure RVCamReceiver1ReceiveUserData(Sender: TObject;
      SessionKey: TRVSessionKey; AData: TStream; ASocket: TRVSocket; AGUIDFrom,
      AGUIDTo, AGUIDGroup: TGUID);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
RVMediaServer1.GUIDMy := '{00000000-0000-9999-0000-000000000000}';
Memo1.Lines.Add('RVMediaServer1.GUIDMy = {00000000-0000-9999-0000-000000000000}');
RVMediaServer1.HTTPPort := 24200;
Memo1.Lines.Add('HTTPPort = 24200');
if  not DirectoryExists (GetCurrentDir+'\Temp') then ForceDirectories(GetCurrentDir+'\Temp');
RVMediaServer1.TempFolder := GetCurrentDir+'\Temp\';
Memo1.Lines.Add('TempFolder: '+RVMediaServer1.TempFolder);
RVMediaServer1.HTTPActive := true;
Memo1.Lines.Add(' ');

RVCamSender1.TCPConnectionType := rvtcpSenderToReceiver;
RVCamSender1.Protocol := rvpTCP;
RVCamSender1.ReceiverHost := Edit1.Text;
RVCamSender1.ReceiverPort := 24200;
//RVCamSender1.SenderPort := 24200;
RVCamSender1.GUIDFrom := '{00000000-0000-0001-0000-000000000000}';

RVCamReceiver1.TCPConnectionType := rvtcpReceiverToSender;
RVCamReceiver1.Protocol := rvpTCP;
RVCamReceiver1.Senders.Add;
RVCamReceiver1.Senders[0].SenderHost := Edit1.Text;
RVCamReceiver1.Senders[0].SenderPort := 24200;
RVCamReceiver1.GUIDMy := '{00000000-0000-0001-0000-000000000000}';

RVCamSender1.Active := true;
RVCamReceiver1.Active := true;
Memo1.Lines.Add('   ');
Memo1.Lines.Add('    .');

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
RVCamSender1.Active := false;
RVCamReceiver1.Active := false;
RVCamSender2.Active := false;
RVCamReceiver2.Active := false;

RVMediaServer1.HTTPActive := false;
Memo1.Lines.Add(',    .');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
Memo1.Lines.Add('GetAllUsers --->');
RVCamSender1.GetAllUsers;
Memo1.Lines.Add('GetAllOnlineUsers --->');
RVCamSender1.GetAllOnlineUsers;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
Memo1.Lines.Add(IntToStr(RVCamSender1.SessionKey));
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
RVCamSender2.TCPConnectionType := rvtcpSenderToReceiver;
RVCamSender2.Protocol := rvpTCP;
RVCamSender2.ReceiverHost := Edit2.Text;
RVCamSender2.ReceiverPort := 24200;
//RVCamSender2.SenderPort := 24200;
RVCamSender2.GUIDFrom := Edit3.Text;

RVCamReceiver2.TCPConnectionType := rvtcpReceiverToSender;
RVCamReceiver2.Protocol := rvpTCP;
RVCamReceiver2.Senders.Add;
RVCamReceiver2.Senders[0].SenderHost := Edit2.Text;
RVCamReceiver2.Senders[0].SenderPort := 24200;
RVCamReceiver2.GUIDMy := Edit3.Text;;

RVCamSender2.Active := true;
RVCamReceiver2.Active := true;
Memo1.Lines.Add('2  2 ');
Memo1.Lines.Add('    .');
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  Stream: TMemoryStream;
  s:      String;
begin
  s := Edit4.Text;
  Stream := TMemoryStream.Create;
  try
    Stream.WriteBuffer(PChar(s)^, Length(s) * sizeof(Char));
    RVCamSender2.SendUserData(Stream, '{00000000-0000-0001-0000-000000000000}');
  finally
    Stream.Free;
  end;
  Edit4.Text := '';
  Edit4.SetFocus;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Edit1.Text := GetLocalHostAddress;
Edit2.Text := GetLocalHostAddress;
Edit3.Text := '{00000000-0000-0000-0001-000000000000}';
end;

procedure TForm1.RVCamReceiver1GetAllOnlineUsers(Sender: TRVCamReceiver;
  SessionKey: TRVSessionKey; const GUIDGroup, GUIDUser: TRVMAnsiString;
  ACmd: TRVCmd);
begin
Memo1.Lines.Add('RVCamReceiver1GetAllOnlineUsers');
Memo1.Lines.Add(GUIDUser);
end;

procedure TForm1.RVCamReceiver1GetAllUsers(Sender: TRVCamReceiver;
  SessionKey: TRVSessionKey; const GUIDGroup, GUIDUser: TRVMAnsiString;
  ACmd: TRVCmd);
var
acikl : integer;
begin
Memo1.Lines.Add('RVCamReceiver1GetAllUsers');
Memo1.Lines.Add(GUIDUser);
For acikl := 1 to (ACmd.ParamByName('GUIDCount').AsInteger) do
  begin
  Memo1.Lines.Add(ACmd.ParamByName(TRVMAnsiString('GUIDUser'+IntToStr(acikl))).AsString);
  end;
end;

procedure TForm1.RVCamReceiver1ReceiveUserData(Sender: TObject;
  SessionKey: TRVSessionKey; AData: TStream; ASocket: TRVSocket; AGUIDFrom,
  AGUIDTo, AGUIDGroup: TGUID);
var
  s: String;
begin
  if AData.Size mod sizeof(Char) = 1 then
    exit;
  SetLength(s, AData.Size div sizeof(Char));
  AData.Position := 0;
  AData.ReadBuffer(PChar(s)^, AData.Size);
  Memo1.Lines.Add('Message is received: ' + s);
end;

procedure TForm1.RVMediaServer1ServerCmd(Sender: TRVMediaServer; const GUIDUser,
  GUIDToUser, GUIDGroupUser: TRVMAnsiString; ServerCMD: TRVCmd);
begin
Memo1.Lines.Add('RVMediaServer1ServerCmd');
end;

procedure TForm1.RVMediaServer1UserConnect(Sender: TRVMediaServer;
  const GUIDUser: TRVMAnsiString; MediaType: TRVMediaType);
begin
if MediaType = rvmtVideo then Memo1.Lines.Add('rvmtVideo');
if MediaType = rvmtAudio then Memo1.Lines.Add('rvmtAudio');
if MediaType = rvmtUserData then Memo1.Lines.Add('rvmtUserData');
if MediaType = rvmtFileData then Memo1.Lines.Add('rvmtFileData');
if MediaType = rvmtCmdData then Memo1.Lines.Add('rvmtCmdData');
Memo1.Lines.Add(GUIDUser);
end;

end.
